//----------------------------------------------------------------
//
// NeuroMatrix NM6403, C runtime library
// 2001 (c) RC Module Inc.
// memcpy.asm,
//
//----------------------------------------------------------------

//#include <string.h>

//#ifdef __cplusplus
//extern "C"
//#endif
//void * memcpy(void * dest,const void * src, size_t len)
//{
// register char *d,*s;
//
//  d=(char *)dest; s=(char*)src;
//  if (dest < src)
//    while (len--)
//      *d++ = *s++;
//  else
//    {
//      char *lasts,*lastd;
//
//      lastd= d + (len-1);
//      lasts = s + (len-1);
//      while (len--)
//       *lastd-- = *lasts--;
//    }
//  return dest;
//}

global _memcpy : label;

begin ".text"

<_memcpy>
    push ar0,gr0;
    push ar1,gr1;
    ar5 = ar7 - 6;
    
    gr1 = [ --ar5 ]; //dest
    gr0 = [ --ar5 ]; //src
    with gr0 - gr1;
    
    if u>= delayed skip backcopy;
    ar1 = gr1 with gr7 = gr1;
    ar0 = gr0;
    // end of delayed skip

    gr0 = [ --ar5 ]; //len
    with gr0;
    if =0 skip endfunc;

    with gr0--;
<copyloop> 
    if > delayed skip copyloop with gr0--;
    gr1 = [ ar0++ ];
    [ ar1++ ] = gr1;
    // end of delayed skip
    
    skip endfunc;
    
<backcopy>
    
    gr0 = [ --ar5 ]; //len
    with gr0;
    if =0 delayed skip endfunc;
    ar0 = ar0 + gr0 with gr1 = gr0;
    ar1 = ar1 + gr1;
    // end of delayed skip

    with gr0--;
<backcopyloop>
    if > delayed skip backcopyloop with gr0--;
    gr1 = [ --ar0 ];
    [ --ar1 ] = gr1;
    // end of delayed skip
    
<endfunc>    
    ar5 = gr7;
    pop ar1,gr1;
    pop ar0,gr0;
    return;

end ".text";
