//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// strcat.c,
//
//----------------------------------------------------------------

#include <string.h>

#ifdef __cplusplus
extern "C"
#endif
char * strcat (char *dest, const char *src)
{
  register char *s1 = dest;
  register const char *s2 = src;
  char c;

  do
    c = *s1++;
  while (c != '\0');

  s1 -= 2;

  do
    {
      c = *s2++;
      *++s1 = c;
    }
  while (c != '\0');

  return dest;
}
