/*
 *	Copyright (c) 1993-1996 by Research Computer Center (Expert Team)
 *	Moscow State University, Moscow, Russia
 *	All rights reserved.
 *
 *	%W%     %E%     (c) SRCC
 */

#include <exception>

#include <stdio.h>
#include <stdlib.h>

_USING_STD(unexpected_handler)
_USING_STD(terminate)

static unexpected_handler _unexpected_handler = (unexpected_handler) terminate;

_NS_STD_BEGIN

unexpected_handler
set_unexpected (unexpected_handler f)
{
    unexpected_handler ret = _unexpected_handler;

    if (f == 0) {
        // fprintf (stderr, "std::set_unexpected(): 0 parameter");
        abort ();
    };

    _unexpected_handler = f;
    return ret;
}

void
unexpected ()
{
    _unexpected_handler ();
}

_NS_STD_END
